/**
 * Created by Administrator on 2016/1/15.
 */
;(function () {
    var remoteHost = 'http://stat.babmai.com.cn';
    //事件和事件类型
    var etype = {
        'process': 'process',
        'action': 'action'
    }, event = {
        'init': 'init',
        'active': 'active',
        'unload': 'unload',
        'tap': 'tap',
        'click': 'click'
    };
    var globalWrapClass = 'bbm-wrap';

    function BBM_STATE() {
        var _this = this;
        function init(){
            window.addEventListener('beforeunload', function(){
                _this.saveUnload();
            });
            func.save();
        }
        init();
    }

    var func = BBM_STATE;
    func.serialize = function (d) {
        var arr = [];
        for (var i in d) {
            arr.push(i + '=' + d[i]);
        }
        return arr.join('&');
    };
    func.saveData = function (d) {
        var img = null;
        if (window.Image) {
            img = new Image();
        } else {
            img = document.createElement('img');
        }
        img.onload = function (e) {
            img = null;
        };
        img.src =  remoteHost + '/state?' + func.serialize(d);
    };
    func.save = function (d) {
        var data = func.getData(d);
        func.saveData(data);
    };
    func.getData = function (opt) {
        var d = {};
        d.project = _getProject(),
            d.url = location.href,
            d.ref = document.referrer,
            d.r = Math.random(),
            d.token = _getLocalStorage('token'),
            d.passport = _getLocalStorage('passport'),
            d.etype = etype.process,
            d.event = event.init,
            d.time = +new Date,
            d.resolution = _getResolution(),
            d.viewsize = _getViewSize(),
            d.pagesize = _getPageSize(),
            d.pagescroll = _getPageScroll(),
            d.ua = navigator.userAgent;
        for (var i in opt) {
            d[i] = opt[i];
        }
        return d;
        /**
         * http://m.babamai.com.cn/mobile/sft_order_yg2.html
         * -> m_babamai,mobile
         * @private
         */
        function _getProject() {
            var host = location.host;
            var dTop = ['com.cn', 'net.cn', 'org.cn', 'gov.cn'];
            host = host.replace(/^www\./, '');
            host = host.replace(/(com|net|org|gov)\.cn$/, 'xcn');
            //host = host.substring(0, host.lastIndexOf('.'));
            host = host.substring(0, host.lastIndexOf('.'));
            var t1 = [];
            if (host) {
                t1 = host.split('.');
            }
            var pathname = location.pathname;
            pathname = pathname.replace(/^\//, '');
            pathname = pathname.substring(0, pathname.lastIndexOf('/'));
            var t2 = [];
            if (pathname) {
                t2 = pathname.split('/');
            }
            return t1.join('.') + ',' + t2.join('/');
        }

        function _getLocalStorage(s) {
            var v = localStorage.getItem(s)
            return v ? v : '';
        }

        function _getResolution() {
            return screen.width + '/' + screen.height;
        }

        function _getViewSize() {
            var de = document.documentElement;
            return de.clientWidth + '/' + de.clientHeight;
        }

        function _getPageSize() {
            var target = document.body;
            var tar = document.getElementsByClassName(globalWrapClass);
            if (tar.length) {
                target = tar[0];
            }
            return target.offsetWidth + '/' + target.offsetHeight;
        }

        function _getPageScroll() {
            var x = window.scrollX || document.body.scrollLeft || document.documentElement.scrollLeft,
                y = window.scrollY || document.body.scrollTop || document.documentElement.scrollTop;
            return x + '/' + y;
        }
    };
    func.getSource = function (i) {
        var source = '';
        if(i instanceof  HTMLElement){
            source = i.getAttribute('data-stateid');
        }else if(typeof i === 'string'){
            source = i;
        }
        return source;
    };

    var proto = BBM_STATE.prototype;
    proto.saveTap = function (i) {
        var d = {
            esource: func.getSource(i),
            etype: etype.action,
            event: event.tap
        }
        func.save(d);
    };
    proto.saveClick = function(i){
        var d = {
            esource: func.getSource(i),
            etype: etype.action,
            event:event.click
        }
        func.save(d);
    };
    proto.saveUnload = function(){
        func.save({
            eytpe: etype.process,
            event: event.unload
        });
    };

    if (!window.BBM_STATE) {
        window.BBM_STATE = new BBM_STATE();
    }
})();